###################################################
### chunk number 1: lib
###################################################
rm(list=ls(all=TRUE))
options(width=60)
library(MAMA)
load(url("http://math.muni.cz/~xihnatov/DataColonHalf.RData"))
ls()
#source("C:\\Users\\user\\Desktop\\Diplomovka CD\\meta-analyza.R")


###################################################
### chunk number 2: datap2
###################################################
esets<-list(exprs(denmark),exprs(australia),exprs(japan))
classes<-list(pData(denmark)[,1],pData(australia)[,1], pData(japan)[,2])


###################################################
### chunk number 3: DEGp
###################################################
pvalt<-pvalcombination(esets, classes, moderated = "t" , BHth = 0.01)


###################################################
### chunk number 4: resp
###################################################
summary(pvalt)


###################################################
### chunk number 5: 
###################################################
esets<-list(exprs(denmark),exprs(australia),exprs(japan))
classes<-list(pData(denmark)[,1],pData(australia)[,1], pData(japan)[,2])


###################################################
### chunk number 6: ESmetaMA
###################################################
ESt<-EScombination(esets, classes, moderated = "t" , BHth = 0.01)


###################################################
### chunk number 7: 
###################################################
summary(ESt)


###################################################
### chunk number 8: 
###################################################
ph1<-pData(denmark)[,1]
levels(ph1) <- c(1, 0)
pData(denmark)[,1]
ph1


###################################################
### chunk number 9: 
###################################################
ph2<-pData(australia)[,1]
levels(ph2) <- c(1, 0)
ph3<-pData(japan)[,2]
levels(ph3) <- c(1, 0)



###################################################
### chunk number 10: ESGeneMeta
###################################################
d.den <- getdF(denmark, ph1)
d.adj.den <- dstar(d.den, length(ph1))
var.d.adj.den <- sigmad(d.adj.den, sum(ph1 == 0), sum(ph1 == 1))
head(d.adj.den)
head(var.d.adj.den)


###################################################
### chunk number 11: 
###################################################
d.aus <- getdF(australia, ph2)
d.adj.aus <- dstar(d.aus, length(ph2))
var.d.adj.aus <- sigmad(d.adj.aus, sum(ph2 == 0), sum(ph2 == 1))
d.jap <- getdF(japan, ph3)
d.adj.jap <- dstar(d.jap, length(ph3))
var.d.adj.jap <- sigmad(d.adj.jap, sum(ph3 == 0), sum(ph3 == 1))


###################################################
### chunk number 12: 
###################################################
mymns <- cbind(d.adj.den, d.adj.aus,d.adj.jap)
myvars <- cbind(var.d.adj.den, var.d.adj.aus,var.d.adj.jap)
my.Q <- f.Q(mymns, myvars)
mean(my.Q)
hist(my.Q, breaks = 50, col = "red")


###################################################
### chunk number 13: 
###################################################
num.studies <- 3
plotQvsChi(my.Q, num.studies)


###################################################
### chunk number 14: 
###################################################
#FEM
muFEM = mu.tau2(mymns, myvars)
sdFEM = var.tau2(myvars)
ZFEM = muFEM/sqrt(sdFEM)
qqnorm(ZFEM, pch = "*")
qqline(ZFEM, col = "red")


###################################################
### chunk number 15: 
###################################################
#REM
num.studies <- 3
my.tau2.DL <- tau2.DL(my.Q, num.studies, my.weights=1/myvars)
myvarsDL <- myvars + my.tau2.DL
muREM <- mu.tau2(mymns, myvarsDL)
varREM <- var.tau2(myvarsDL)
ZREM <- muREM/sqrt(varREM)


###################################################
### chunk number 16: 
###################################################
plot(muFEM, muREM, pch = "*")
abline(0, 1, col = "red")


###################################################
### chunk number 17: 
###################################################
hist.tau<-hist(my.tau2.DL, col = "red", breaks = 100, main = "Histogram of tau")


###################################################
### chunk number 18: 
###################################################
esets <- list(denmark, australia, japan)
classes <- list(ph1, ph2, ph3)
theScores <- zScores(esets, classes, useREM = FALSE)
round(theScores[1:2, ],3)


###################################################
### chunk number 19: 
###################################################
ScoresFDR <- zScoreFDR(esets, classes, useREM = FALSE, nperm = 50, CombineExp = 1:3)
names(ScoresFDR) 
round(ScoresFDR$pos[1:2, ],3)


###################################################
### chunk number 20: 
###################################################
plotES(theScores, ScoresFDR, num.studies=3, legend.names=c("Combined set", "Denmark", "Australia", "Japan"), colors=c("red","blue","green","yellow"), which=1:3)


###################################################
### chunk number 21: SOGLdata
###################################################
denmarkSOGL<-dataSOGL(data=denmark, group=1, groupname="satelite", annotation="hgu133plus2")
australiaSOGL<-dataSOGL(data=australia,group=1, groupname="satelite",annotation="hgu133plus2")
A <- prepareData(eset1 = list(data = denmarkSOGL, name = "colon_cancer1", var = "groupname", out = c(1, 2), paired = FALSE), eset2 = list(data = australiaSOGL,  name = "colon_cancer2", var = "groupname", out = c(1, 2), paired = FALSE), mapping=NULL)


###################################################
### chunk number 22: SOGLvyp
###################################################
x.z <- OrderedList(A, empirical = TRUE)
x.z


###################################################
### chunk number 23: 
###################################################
x.z$intersect[1:12]


###################################################
### chunk number 24: 
###################################################
plot(x.z,"pauc")


###################################################
### chunk number 25: 
###################################################
plot(x.z,"scores")


###################################################
### chunk number 26: 
###################################################
plot(x.z,"overlap")


###################################################
### chunk number 27: rankdata
###################################################
rankdata<-mergedata(denmark, australia, japan, class.col=c(1,1,2))
rankdata$cl
rankdata$origin


###################################################
### chunk number 28: rankDEG
###################################################
RP.out<-RPadvance(rankdata$dat,rankdata$cl,rankdata$origin,num.perm=50,logged=TRUE,na.rm=FALSE,gene.names=rownames(exprs(denmark)), plot=FALSE)


###################################################
### chunk number 29: 
###################################################
plotRP(RP.out, cutoff=0.01)


###################################################
### chunk number 30: 
###################################################
RankRes<-topGene(RP.out, cutoff=0.01)
head(round(RankRes$Table1,3))
head(round(RankRes$Table2,3))


###################################################
### chunk number 31: Zdata
###################################################
table(pData(denmark)[,1])
table(pData(australia)[,1])
table(pData(japan)[,2])


###################################################
### chunk number 32: Zdata2
###################################################
denmarkZ<-dataZ(data=denmark, group=1, nsamp=5, varname="satelite")
australiaZ<-dataZ(australia,1,5,"satelite")
japanZ<-dataZ(japan,2,5,"satelite")
library(MergeMaid)
merged<-mergeExprs(denmarkZ,australiaZ,japanZ)


###################################################
### chunk number 33: Zdeg
###################################################
z.stat<-Zscore(merged)


###################################################
### chunk number 34: 
###################################################
head(round(z.stat,3))


###################################################
### chunk number 35: TSPdata
###################################################
tspdata<-mergedata(denmark, australia, japan, class.col=c(1,1,2))


###################################################
### chunk number 36: TSPdeg
###################################################
tsp<-tspcalc(dat=tspdata$dat, grp=tspdata$cl)


###################################################
### chunk number 37: 
###################################################
out<-tspsig(tspdata$dat,tspdata$cl,B=50)


###################################################
### chunk number 38: TSPres
###################################################
tsp


###################################################
### chunk number 39: 
###################################################
tspplot(tsp)


###################################################
### chunk number 40: 
###################################################
summary(out)
out$p
out$nullscores


###################################################
### chunk number 41: VennFCH
###################################################
fc.d<-fold.change(denmark,1)
fc.a<-fold.change(australia,1)
fc.j<-fold.change(japan,2)
FC<-cbind(fc.d, fc.a, fc.j)


###################################################
### chunk number 42: 
###################################################
list<-gene.select.FC(FC,1)
summary(list)


###################################################
### chunk number 43: 
###################################################
conting.tab(list)
Z(list, n=length(rownames(exprs(denmark))))
gene.list(list)


###################################################
### chunk number 44: 
###################################################
stat.real<-meta.test(denmark, australia,japan, class.col=c(1,1,2), data.names=c("denmark","australia","japan"))$test
colnames(stat.real)<-c("Denmark","Australia","Japan")


###################################################
### chunk number 45: MAPTcutoff
###################################################
stat<-c(stat.real)
quan<-T.select(stat)
T.default <- quan["98.00%"]


###################################################
### chunk number 46: 
###################################################
value.dis <- apply(stat.real,MARGIN=c(1,2), function(x) ifelse(abs(x)>T.default,1,0))
rownames(value.dis)<-featureNames(denmark)
head(value.dis)


###################################################
### chunk number 47: ratio
###################################################
results<-ratio(value.dis)
summary(results)


###################################################
### chunk number 48: allpatterns
###################################################
MAPmat<-MAPmatrix(value.dis)
MAPmat


###################################################
### chunk number 49: selpaternX
###################################################
MAPmat2<-MAPmat[MAPmat$n.sig>1,]
unique.pat<-as.character(MAPmat2[,1])


###################################################
### chunk number 50: MAPsig1
###################################################
p1<-MAPsig1(unique.pat,value.dis,iter=1000)
p1


###################################################
### chunk number 51: MAPsig2
###################################################
den.shuf<-test.group.shuffle(data=denmark, dataname="Denmark")
aus.shuf<-test.group.shuffle(data=australia, dataname="Australia")
jap.shuf<-test.group.shuffle(data=japan, dataname="Japan",var=2)
dataset <- c("Denmark","Australia","Japan")
p2<-MAPsig2(dataset, value.dis, unique.pat, B=100)


###################################################
### chunk number 52: 
###################################################
p2


###################################################
### chunk number 53: MAPres
###################################################
resx <- cbind(MAPmat2, p1, p2)
colnames(resx) <-c(colnames(MAPmat2), "p.strong", "p.weak", "p.permu.strong", "p.permu.weak")
intx <- t(as.matrix(resx[which(resx[,4]<0.06),]))
t(resx)


###################################################
### chunk number 54: 
###################################################
plotpattern(resx, method=1)


###################################################
### chunk number 55: 
###################################################
plotpattern(resx, method=2)


###################################################
### chunk number 56: 
###################################################
probs<-MAP.genes(resx,value.dis, files=FALSE)
names(probs)<-rownames(resx)
summary(probs)


###################################################
### chunk number 57: MAPanno
###################################################
library(annaffy)
library(hgu133plus2.db)
MAP.HTMLanno(resx, probs, "hgu133plus2.db")


###################################################
### chunk number 58: METRAdat
###################################################
metra<-meta.test(denmark, australia,japan, class.col=c(1,1,2), data.names=c("denmark","australia","japan"))
head(metra$test)


###################################################
### chunk number 59: 
###################################################
RANK<-rank.genes.adv(metra)
head(RANK)


###################################################
### chunk number 60: 
###################################################
RANK2<-RANK[order(RANK[,1]),]
colnames(RANK2)<-c("Denmark","Australia", "Japan")
heatcol<-colorRampPalette(c("Green", "Black", "Red"))(100)
metaheat(as.matrix(RANK2), col=heatcol)


###################################################
### chunk number 61: METRArq
###################################################
RQ<-compute.RQ(RANK)
head(round(RQ,1))


###################################################
### chunk number 62: METRAmc
###################################################
MC<-MCtest(RANK,RQ, nper=1000)
head(MC)


###################################################
### chunk number 63: 
###################################################
METRA<-c(rownames(MC)[MC[,1]<0.01 & MC[,4]<0.01], rownames(MC)[MC[,2]<0.01 & MC[,4]<0.01])
METRA[1:10]


###################################################
### chunk number 64: 
###################################################
lists<-join.DEG(pvalt, ESt, ScoresFDR, x.z, RankRes, z.stat, tsp, probs,genenames=featureNames(denmark), type=c(1,1,3,4,5,6,7,8), cutoff=0.01)
names(lists)<-c("PvalCom", "ESCom","ESCom2","OrderedList","RankProduct", "Z-stat","TSP","MAP")
summary(lists)


###################################################
### chunk number 65: 
###################################################
MAT<-make.matrix(lists)
MAT[1:5,1:5]


###################################################
### chunk number 66: 
###################################################
metaheat(MAT, legend=1, col=c("khaki1", "lightsalmon3"))


###################################################
### chunk number 67: 
###################################################
metaheat2(MAT, col=c("khaki1", "lightsalmon3"), legend.names=c("DEG","noDEG"), discrete=TRUE, trace="none", dendrogram="none")


###################################################
### chunk number 68: 
###################################################
dim(MAT)


###################################################
### chunk number 69: 
###################################################
n.met<-apply(MAT,1,sum)
hist(n.met, main="", xlab="Number of methods", ylab="Number of genes", xlim=c(1,8))


###################################################
### chunk number 70: 
###################################################
dim(MAT[n.met>5,])


###################################################
### chunk number 71: 
###################################################
n.gen<-apply(MAT,2,sum)
barplot(n.gen, cex.names=0.8, las=2)


###################################################
### chunk number 72: 
###################################################
TAB<-conting.tab(lists)
TAB[1:5,1:5]


###################################################
### chunk number 73: 
###################################################
results<-join.results(pvalt, ESt, theScores, ScoresFDR$two.sided, x.z, RankRes, z.stat, probs, MC, RQ, type=c(1,1,5,5,2,3,5,4,5,5), genenames=rownames(exprs(denmark)))
gene<-metagene("203008_x_at",results)
gene
save(gene,file="gen.RData")


###################################################
### chunk number 74: 
###################################################
plotgene(gene, type=c(1,1,2,3,4,5,6,7,8,9), datalabels=c("denmark", "australia", "japan", "combined"))


